diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/bindings/modulegen__gcc_LP64.py ns-3.31/src/applications/bindings/modulegen__gcc_LP64.py
--- ns-3.30.1/src/applications/bindings/modulegen__gcc_LP64.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/applications/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
@@ -12498,12 +12680,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::Socket>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Socket> arg0, unsigned int arg1) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Socket >', 'arg0'), param('unsigned int', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -12520,12 +12702,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()() [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -12542,12 +12724,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(unsigned int arg0) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('unsigned int', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CallbackImpl__Void_Unsigned_int_Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -12564,12 +12746,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, unsigned int, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(unsigned int arg0, unsigned int arg1) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('unsigned int', 'arg0'), param('unsigned int', 'arg1')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
     return
 
 def register_Ns3CounterCalculator__Unsigned_int_methods(root_module, cls):
@@ -12591,7 +12773,7 @@
     cls.add_method('Output', 
                    'void', 
                    [param('ns3::DataOutputCallback &', 'callback')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## basic-data-calculators.h (module 'stats'): void ns3::CounterCalculator<unsigned int>::Update() [member function]
     cls.add_method('Update', 
                    'void', 
@@ -12604,7 +12786,7 @@
     cls.add_method('DoDispose', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='protected')
+                   visibility='protected', is_virtual=True)
     return
 
 def register_Ns3DropTailQueue__Ns3Packet_methods(root_module, cls):
@@ -12634,7 +12816,7 @@
     cls.add_method('Peek', 
                    'ns3::Ptr< ns3::Packet const >', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## drop-tail-queue.h (module 'network'): ns3::DropTailQueue<ns3::Packet>::DropTailQueue(ns3::DropTailQueue<ns3::Packet> const & arg0) [constructor]
     cls.add_constructor([param('ns3::DropTailQueue< ns3::Packet > const &', 'arg0')])
     return
@@ -12666,7 +12848,7 @@
     cls.add_method('Peek', 
                    'ns3::Ptr< ns3::QueueDiscItem const >', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## drop-tail-queue.h (module 'network'): ns3::DropTailQueue<ns3::QueueDiscItem>::DropTailQueue(ns3::DropTailQueue<ns3::QueueDiscItem> const & arg0) [constructor]
     cls.add_constructor([param('ns3::DropTailQueue< ns3::QueueDiscItem > const &', 'arg0')])
     return
@@ -12685,12 +12867,12 @@
     cls.add_method('GetDevice', 
                    'ns3::Ptr< ns3::NetDevice >', 
                    [param('std::size_t', 'i')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## error-channel.h (module 'network'): std::size_t ns3::ErrorChannel::GetNDevices() const [member function]
     cls.add_method('GetNDevices', 
                    'std::size_t', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## error-channel.h (module 'network'): static ns3::TypeId ns3::ErrorChannel::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
                    'ns3::TypeId', 
@@ -12741,7 +12923,7 @@
     cls.add_method('DoDispose', 
                    'void', 
                    [], 
-                   is_virtual=True, visibility='protected')
+                   visibility='protected', is_virtual=True)
     return
 
 def register_Ns3PacketProbe_methods(root_module, cls):
@@ -12854,22 +13036,22 @@
     cls.add_method('AddHeader', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue-item.h (module 'network'): void ns3::QueueDiscItem::Print(std::ostream & os) const [member function]
     cls.add_method('Print', 
                    'void', 
                    [param('std::ostream &', 'os')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## queue-item.h (module 'network'): bool ns3::QueueDiscItem::Mark() [member function]
     cls.add_method('Mark', 
                    'bool', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## queue-item.h (module 'network'): uint32_t ns3::QueueDiscItem::Hash(uint32_t perturbation=0) const [member function]
     cls.add_method('Hash', 
                    'uint32_t', 
                    [param('uint32_t', 'perturbation', default_value='0')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
@@ -12881,7 +13063,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -12891,7 +13073,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/examples/three-gpp-http-example.cc ns-3.31/src/applications/examples/three-gpp-http-example.cc
--- ns-3.30.1/src/applications/examples/three-gpp-http-example.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/applications/examples/three-gpp-http-example.cc	2020-06-27 17:38:30.000000000 -0700
@@ -98,7 +98,7 @@
 main (int argc, char *argv[])
 {
   double simTimeSec = 300;
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("SimulationTime", "Length of simulation in seconds.", simTimeSec);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/bulk-send-application.cc ns-3.31/src/applications/model/bulk-send-application.cc
--- ns-3.30.1/src/applications/model/bulk-send-application.cc	2019-09-18 10:36:11.000000000 -0700
+++ ns-3.31/src/applications/model/bulk-send-application.cc	2020-06-27 17:38:30.000000000 -0700
@@ -29,6 +29,7 @@
 #include "ns3/uinteger.h"
 #include "ns3/trace-source-accessor.h"
 #include "ns3/tcp-socket-factory.h"
+#include "ns3/boolean.h"
 #include "bulk-send-application.h"
 
 namespace ns3 {
@@ -52,6 +53,11 @@
                    AddressValue (),
                    MakeAddressAccessor (&BulkSendApplication::m_peer),
                    MakeAddressChecker ())
+    .AddAttribute ("Local",
+                   "The Address on which to bind the socket. If not set, it is generated automatically.",
+                   AddressValue (),
+                   MakeAddressAccessor (&BulkSendApplication::m_local),
+                   MakeAddressChecker ())
     .AddAttribute ("MaxBytes",
                    "The total number of bytes to send. "
                    "Once these bytes are sent, "
@@ -64,9 +70,17 @@
                    TypeIdValue (TcpSocketFactory::GetTypeId ()),
                    MakeTypeIdAccessor (&BulkSendApplication::m_tid),
                    MakeTypeIdChecker ())
-    .AddTraceSource ("Tx", "A new packet is created and is sent",
+    .AddAttribute ("EnableSeqTsSizeHeader",
+                   "Add SeqTsSizeHeader to each packet",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&BulkSendApplication::m_enableSeqTsSizeHeader),
+                   MakeBooleanChecker ())
+    .AddTraceSource ("Tx", "A new packet is sent",
                      MakeTraceSourceAccessor (&BulkSendApplication::m_txTrace),
                      "ns3::Packet::TracedCallback")
+    .AddTraceSource ("TxWithSeqTsSize", "A new packet is created with SeqTsSizeHeader",
+                     MakeTraceSourceAccessor (&BulkSendApplication::m_txTraceWithSeqTsSize),
+                     "ns3::PacketSink::SeqTsSizeCallback")
   ;
   return tid;
 }
@@ -75,7 +89,8 @@
 BulkSendApplication::BulkSendApplication ()
   : m_socket (0),
     m_connected (false),
-    m_totBytes (0)
+    m_totBytes (0),
+    m_unsentPacket (0)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -105,6 +120,7 @@
   NS_LOG_FUNCTION (this);
 
   m_socket = 0;
+  m_unsentPacket = 0;
   // chain up
   Application::DoDispose ();
 }
@@ -113,11 +129,13 @@
 void BulkSendApplication::StartApplication (void) // Called at time specified by Start
 {
   NS_LOG_FUNCTION (this);
+  Address from;
 
   // Create the socket if not already
   if (!m_socket)
     {
       m_socket = Socket::CreateSocket (GetNode (), m_tid);
+      int ret = -1;
 
       // Fatal error if socket type is not NS3_SOCK_STREAM or NS3_SOCK_SEQPACKET
       if (m_socket->GetSocketType () != Socket::NS3_SOCK_STREAM &&
@@ -128,21 +146,30 @@
                           "In other words, use TCP instead of UDP.");
         }
 
-      if (Inet6SocketAddress::IsMatchingType (m_peer))
+      if (! m_local.IsInvalid())
         {
-          if (m_socket->Bind6 () == -1)
-            {
-              NS_FATAL_ERROR ("Failed to bind socket");
-            }
+          NS_ABORT_MSG_IF ((Inet6SocketAddress::IsMatchingType (m_peer) && InetSocketAddress::IsMatchingType (m_local)) ||
+                           (InetSocketAddress::IsMatchingType (m_peer) && Inet6SocketAddress::IsMatchingType (m_local)),
+                           "Incompatible peer and local address IP version");
+          ret = m_socket->Bind (m_local);
         }
-      else if (InetSocketAddress::IsMatchingType (m_peer))
+      else
         {
-          if (m_socket->Bind () == -1)
+          if (Inet6SocketAddress::IsMatchingType (m_peer))
+            {
+              ret = m_socket->Bind6 ();
+            }
+          else if (InetSocketAddress::IsMatchingType (m_peer))
             {
-              NS_FATAL_ERROR ("Failed to bind socket");
+              ret = m_socket->Bind ();
             }
         }
 
+      if (ret == -1)
+        {
+          NS_FATAL_ERROR ("Failed to bind socket");
+        }
+
       m_socket->Connect (m_peer);
       m_socket->ShutdownRecv ();
       m_socket->SetConnectCallback (
@@ -153,7 +180,8 @@
     }
   if (m_connected)
     {
-      SendData ();
+      m_socket->GetSockName (from);
+      SendData (from, m_peer);
     }
 }
 
@@ -175,7 +203,7 @@
 
 // Private helpers
 
-void BulkSendApplication::SendData (void)
+void BulkSendApplication::SendData (const Address &from, const Address &to)
 {
   NS_LOG_FUNCTION (this);
 
@@ -193,20 +221,48 @@
         }
 
       NS_LOG_LOGIC ("sending packet at " << Simulator::Now ());
-      Ptr<Packet> packet = Create<Packet> (toSend);
+
+      Ptr<Packet> packet;
+      if (m_unsentPacket)
+        {
+          packet = m_unsentPacket;
+        }
+      else if (m_enableSeqTsSizeHeader)
+        {
+          SeqTsSizeHeader header;
+          header.SetSeq (m_seq++);
+          header.SetSize (toSend);
+          NS_ABORT_IF (toSend < header.GetSerializedSize ());
+          packet = Create<Packet> (toSend - header.GetSerializedSize ());
+          // Trace before adding header, for consistency with PacketSink
+          m_txTraceWithSeqTsSize (packet, from, to, header);
+          packet->AddHeader (header);
+        }
+      else
+        {
+          packet = Create<Packet> (toSend);
+        }
+
       int actual = m_socket->Send (packet);
-      if (actual > 0)
+      if ((unsigned) actual == toSend)
         {
           m_totBytes += actual;
           m_txTrace (packet);
+          m_unsentPacket = 0;
         }
-      // We exit this loop when actual < toSend as the send side
-      // buffer is full. The "DataSent" callback will pop when
-      // some buffer space has freed up.
-      if ((unsigned)actual != toSend)
+      else if (actual == -1)
         {
+          // We exit this loop when actual < toSend as the send side
+          // buffer is full. The "DataSent" callback will pop when
+          // some buffer space has freed up.
+          NS_LOG_DEBUG ("Unable to send packet; caching for later attempt");
+          m_unsentPacket = packet;
           break;
         }
+      else
+        {
+          NS_FATAL_ERROR ("Unexpected return value from m_socket->Send ()");
+        }
     }
   // Check if time to close (all sent)
   if (m_totBytes == m_maxBytes && m_connected)
@@ -221,7 +277,10 @@
   NS_LOG_FUNCTION (this << socket);
   NS_LOG_LOGIC ("BulkSendApplication Connection succeeded");
   m_connected = true;
-  SendData ();
+  Address from, to;
+  socket->GetSockName (from);
+  socket->GetPeerName (to);
+  SendData (from, to);
 }
 
 void BulkSendApplication::ConnectionFailed (Ptr<Socket> socket)
@@ -230,13 +289,16 @@
   NS_LOG_LOGIC ("BulkSendApplication, Connection Failed");
 }
 
-void BulkSendApplication::DataSend (Ptr<Socket>, uint32_t)
+void BulkSendApplication::DataSend (Ptr<Socket> socket, uint32_t)
 {
   NS_LOG_FUNCTION (this);
 
   if (m_connected)
     { // Only send new data if the connection has completed
-      SendData ();
+      Address from, to;
+      socket->GetSockName (from);
+      socket->GetPeerName (to);
+      SendData (from, to);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/bulk-send-application.h ns-3.31/src/applications/model/bulk-send-application.h
--- ns-3.30.1/src/applications/model/bulk-send-application.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/applications/model/bulk-send-application.h	2020-06-27 17:38:30.000000000 -0700
@@ -26,6 +26,7 @@
 #include "ns3/event-id.h"
 #include "ns3/ptr.h"
 #include "ns3/traced-callback.h"
+#include "ns3/seq-ts-size-header.h"
 
 namespace ns3 {
 
@@ -64,6 +65,12 @@
  * For example, TCP sockets can be used, but
  * UDP sockets can not be used.
  *
+ * If the attribute "EnableSeqTsSizeHeader" is enabled, the application will
+ * use some bytes of the payload to store an header with a sequence number,
+ * a timestamp, and the size of the packet sent. Support for extracting 
+ * statistics from this header have been added to \c ns3::PacketSink 
+ * (enable its "EnableSeqTsSizeHeader" attribute), or users may extract
+ * the header via trace sources.
  */
 class BulkSendApplication : public Application
 {
@@ -108,20 +115,29 @@
 
   /**
    * \brief Send data until the L4 transmission buffer is full.
+   * \param from From address
+   * \param to To address
    */
-  void SendData ();
+  void SendData (const Address &from, const Address &to);
 
   Ptr<Socket>     m_socket;       //!< Associated socket
   Address         m_peer;         //!< Peer address
+  Address         m_local;        //!< Local address to bind to
   bool            m_connected;    //!< True if connected
   uint32_t        m_sendSize;     //!< Size of data to send each time
   uint64_t        m_maxBytes;     //!< Limit total number of bytes sent
   uint64_t        m_totBytes;     //!< Total bytes sent so far
   TypeId          m_tid;          //!< The type of protocol to use.
+  uint32_t        m_seq {0};      //!< Sequence
+  Ptr<Packet>     m_unsentPacket; //!< Variable to cache unsent packet
+  bool            m_enableSeqTsSizeHeader {false}; //!< Enable or disable the SeqTsSizeHeader
 
   /// Traced Callback: sent packets
   TracedCallback<Ptr<const Packet> > m_txTrace;
 
+  /// Callback for tracing the packet Tx events, includes source, destination,  the packet sent, and header
+  TracedCallback<Ptr<const Packet>, const Address &, const Address &, const SeqTsSizeHeader &> m_txTraceWithSeqTsSize;
+
 private:
   /**
    * \brief Connection Succeeded (called by Socket through a callback)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/applications/model/onoff-application.cc ns-3.31/src/applications/model/onoff-application.cc
--- ns-3.30.1/src/applications/model/onoff-application.cc	2019-09-18 10:36:11.000000000 -0700
+++ ns-3.31/src/applications/model/onoff-application.cc	2020-06-27 17:38:30.000000000 -0700
@@ -41,6 +41,7 @@
 #include "ns3/udp-socket-factory.h"
 #include "ns3/string.h"
 #include "ns3/pointer.h"
+#include "ns3/boolean.h"
 
 namespace ns3 {
 
@@ -67,6 +68,11 @@
                    AddressValue (),
                    MakeAddressAccessor (&OnOffApplication::m_peer),
                    MakeAddressChecker ())
+    .AddAttribute ("Local",
+                   "The Address on which to bind the socket. If not set, it is generated automatically.",
+                   AddressValue (),
+                   MakeAddressAccessor (&OnOffApplication::m_local),
+                   MakeAddressChecker ())
     .AddAttribute ("OnTime", "A RandomVariableStream used to pick the duration of the 'On' state.",
                    StringValue ("ns3::ConstantRandomVariable[Constant=1.0]"),
                    MakePointerAccessor (&OnOffApplication::m_onTime),
@@ -88,12 +94,20 @@
                    MakeTypeIdAccessor (&OnOffApplication::m_tid),
                    // This should check for SocketFactory as a parent
                    MakeTypeIdChecker ())
+    .AddAttribute ("EnableSeqTsSizeHeader",
+                   "Enable use of SeqTsSizeHeader for sequence number and timestamp",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&OnOffApplication::m_enableSeqTsSizeHeader),
+                   MakeBooleanChecker ())
     .AddTraceSource ("Tx", "A new packet is created and is sent",
                      MakeTraceSourceAccessor (&OnOffApplication::m_txTrace),
                      "ns3::Packet::TracedCallback")
     .AddTraceSource ("TxWithAddresses", "A new packet is created and is sent",
                      MakeTraceSourceAccessor (&OnOffApplication::m_txTraceWithAddresses),
                      "ns3::Packet::TwoAddressTracedCallback")
+    .AddTraceSource ("TxWithSeqTsSize", "A new packet is created with SeqTsSizeHeader",
+                     MakeTraceSourceAccessor (&OnOffApplication::m_txTraceWithSeqTsSize),
+                     "ns3::PacketSink::SeqTsSizeCallback")
   ;
   return tid;
 }
@@ -104,7 +118,8 @@
     m_connected (false),
     m_residualBits (0),
     m_lastStartTime (Seconds (0)),
-    m_totBytes (0)
+    m_totBytes (0),
+    m_unsentPacket (0)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -144,6 +159,7 @@
 
   CancelEvents ();
   m_socket = 0;
+  m_unsentPacket = 0;
   // chain up
   Application::DoDispose ();
 }
@@ -157,21 +173,33 @@
   if (!m_socket)
     {
       m_socket = Socket::CreateSocket (GetNode (), m_tid);
-      if (Inet6SocketAddress::IsMatchingType (m_peer))
+      int ret = -1;
+
+      if (! m_local.IsInvalid())
         {
-          if (m_socket->Bind6 () == -1)
-            {
-              NS_FATAL_ERROR ("Failed to bind socket");
-            }
+          NS_ABORT_MSG_IF ((Inet6SocketAddress::IsMatchingType (m_peer) && InetSocketAddress::IsMatchingType (m_local)) ||
+                           (InetSocketAddress::IsMatchingType (m_peer) && Inet6SocketAddress::IsMatchingType (m_local)),
+                           "Incompatible peer and local address IP version");
+          ret = m_socket->Bind (m_local);
         }
-      else if (InetSocketAddress::IsMatchingType (m_peer) ||
-               PacketSocketAddress::IsMatchingType (m_peer))
+      else
         {
-          if (m_socket->Bind () == -1)
+          if (Inet6SocketAddress::IsMatchingType (m_peer))
+            {
+              ret = m_socket->Bind6 ();
+            }
+          else if (InetSocketAddress::IsMatchingType (m_peer) ||
+                   PacketSocketAddress::IsMatchingType (m_peer))
             {
-              NS_FATAL_ERROR ("Failed to bind socket");
+              ret = m_socket->Bind ();
             }
         }
+
+      if (ret == -1)
+        {
+          NS_FATAL_ERROR ("Failed to bind socket");
+        }
+
       m_socket->Connect (m_peer);
       m_socket->SetAllowBroadcast (true);
       m_socket->ShutdownRecv ();
@@ -219,6 +247,13 @@
   m_cbrRateFailSafe = m_cbrRate;
   Simulator::Cancel (m_sendEvent);
   Simulator::Cancel (m_startStopEvent);
+  // Canceling events may cause discontinuity in sequence number if the
+  // SeqTsSizeHeader is header, and m_unsentPacket is true
+  if (m_unsentPacket)
+    {
+      NS_LOG_DEBUG ("Discarding cached packet upon CancelEvents ()");
+    }
+  m_unsentPacket = 0;
 }
 
 // Event handlers
@@ -245,17 +280,19 @@
 
   if (m_maxBytes == 0 || m_totBytes < m_maxBytes)
     {
+      NS_ABORT_MSG_IF (m_residualBits > m_pktSize * 8, "Calculation to compute next send time will overflow");
       uint32_t bits = m_pktSize * 8 - m_residualBits;
       NS_LOG_LOGIC ("bits = " << bits);
       Time nextTime (Seconds (bits /
                               static_cast<double>(m_cbrRate.GetBitRate ()))); // Time till next packet
-      NS_LOG_LOGIC ("nextTime = " << nextTime);
+      NS_LOG_LOGIC ("nextTime = " << nextTime.As (Time::S));
       m_sendEvent = Simulator::Schedule (nextTime,
                                          &OnOffApplication::SendPacket, this);
     }
   else
     { // All done, cancel any pending events
       StopApplication ();
+      exit(1);
     }
 }
 
@@ -264,7 +301,7 @@
   NS_LOG_FUNCTION (this);
 
   Time offInterval = Seconds (m_offTime->GetValue ());
-  NS_LOG_LOGIC ("start at " << offInterval);
+  NS_LOG_LOGIC ("start at " << offInterval.As (Time::S));
   m_startStopEvent = Simulator::Schedule (offInterval, &OnOffApplication::StartSending, this);
 }
 
@@ -273,7 +310,7 @@
   NS_LOG_FUNCTION (this);
 
   Time onInterval = Seconds (m_onTime->GetValue ());
-  NS_LOG_LOGIC ("stop at " << onInterval);
+  NS_LOG_LOGIC ("stop at " << onInterval.As (Time::S));
   m_startStopEvent = Simulator::Schedule (onInterval, &OnOffApplication::StopSending, this);
 }
 
@@ -283,34 +320,67 @@
   NS_LOG_FUNCTION (this);
 
   NS_ASSERT (m_sendEvent.IsExpired ());
-  Ptr<Packet> packet = Create<Packet> (m_pktSize);
-  m_txTrace (packet);
-  m_socket->Send (packet);
-  m_totBytes += m_pktSize;
-  Address localAddress;
-  m_socket->GetSockName (localAddress);
-  if (InetSocketAddress::IsMatchingType (m_peer))
+
+  Ptr<Packet> packet;
+  if (m_unsentPacket)
     {
-      NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds ()
-                   << "s on-off application sent "
-                   <<  packet->GetSize () << " bytes to "
-                   << InetSocketAddress::ConvertFrom(m_peer).GetIpv4 ()
-                   << " port " << InetSocketAddress::ConvertFrom (m_peer).GetPort ()
-                   << " total Tx " << m_totBytes << " bytes");
-      m_txTraceWithAddresses (packet, localAddress, InetSocketAddress::ConvertFrom (m_peer));
+      packet = m_unsentPacket;
     }
-  else if (Inet6SocketAddress::IsMatchingType (m_peer))
+  else if (m_enableSeqTsSizeHeader)
     {
-      NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds ()
-                   << "s on-off application sent "
-                   <<  packet->GetSize () << " bytes to "
-                   << Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6 ()
-                   << " port " << Inet6SocketAddress::ConvertFrom (m_peer).GetPort ()
-                   << " total Tx " << m_totBytes << " bytes");
-      m_txTraceWithAddresses (packet, localAddress, Inet6SocketAddress::ConvertFrom(m_peer));
+      Address from, to;
+      m_socket->GetSockName (from);
+      m_socket->GetPeerName (to);
+      SeqTsSizeHeader header;
+      header.SetSeq (m_seq++);
+      header.SetSize (m_pktSize);
+      NS_ABORT_IF (m_pktSize < header.GetSerializedSize ());
+      packet = Create<Packet> (m_pktSize - header.GetSerializedSize ());
+      // Trace before adding header, for consistency with PacketSink
+      m_txTraceWithSeqTsSize (packet, from, to, header);
+      packet->AddHeader (header);
+    }
+  else
+    {
+      packet = Create<Packet> (m_pktSize);
+    }
+
+  int actual = m_socket->Send (packet);
+  if ((unsigned) actual == m_pktSize)
+    {
+      m_txTrace (packet);
+      m_totBytes += m_pktSize;
+      m_unsentPacket = 0;
+      Address localAddress;
+      m_socket->GetSockName (localAddress);
+      if (InetSocketAddress::IsMatchingType (m_peer))
+        {
+          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds ()
+                       << "s on-off application sent "
+                       <<  packet->GetSize () << " bytes to "
+                       << InetSocketAddress::ConvertFrom(m_peer).GetIpv4 ()
+                       << " port " << InetSocketAddress::ConvertFrom (m_peer).GetPort ()
+                       << " total Tx " << m_totBytes << " bytes");
+          m_txTraceWithAddresses (packet, localAddress, InetSocketAddress::ConvertFrom (m_peer));
+        }
+      else if (Inet6SocketAddress::IsMatchingType (m_peer))
+        {
+          NS_LOG_INFO ("At time " << Simulator::Now ().GetSeconds ()
+                       << "s on-off application sent "
+                       <<  packet->GetSize () << " bytes to "
+                       << Inet6SocketAddress::ConvertFrom(m_peer).GetIpv6 ()
+                       << " port " << Inet6SocketAddress::ConvertFrom (m_peer).GetPort ()
+                       << " total Tx " << m_totBytes << " bytes");
+          m_txTraceWithAddresses (packet, localAddress, Inet6SocketAddress::ConvertFrom(m_peer));
+        }
+    }
+  else
+    {
+      NS_LOG_DEBUG ("Unable to send packet; actual " << actual << " size " << m_pktSize << "; caching for later attempt");
+      m_unsentPacket = packet;
     }
-  m_lastStartTime = Simulator::Now ();
   m_residualBits = 0;
+  m_lastStartTime = Simulator::Now ();
   ScheduleNextTx ();
 }
 
@@ -324,6 +394,7 @@
 void OnOffApplication::ConnectionFailed (Ptr<Socket> socket)
 {
   NS_LOG_FUNCTION (this << socket);
+  NS_FATAL_ERROR ("Can't connect");
 }
 
 
